/*
 * Rotating Logo Applet
 * polygonizer.java -- contains the tools needing for converting a b/w image to
 *	a set of polygons
 * (C) 1998 Filip Pizlo
 */

import java.awt.*;
import java.awt.image.*;
import java.util.*;

public final class polygonizer {
 static int DISTANCE=600;
 public static final Vector img2poly(Image img,Dimension size,int crappyness) throws Throwable {
  int[] pix=new int[size.width*size.height];
  PixelGrabber pg=new PixelGrabber(img,0,0,size.width,size.height,pix,0,size.width);
  if (!pg.grabPixels()) throw new Exception("DAMMIT!!  Some idiot aborted pixel grabbing...");
  System.out.println("here");
  Dimension size2=new Dimension(size.width-1,size.height-1);
  boolean[] pix2=new boolean[size2.width*size2.height];
  int ibg=pix[0];
  for (int j=0;j<size2.height;j++) for (int i=0;i<size2.width;i++) {
   int c1=i+(j*size.width),c2=i+(j*size2.width);
   if ((pix[c1]==ibg)!=(pix[c1+1]==ibg)) pix2[c2]=true;
   else pix2[c2]=false;
  }
  for (int j=0;j<size2.width;j++) for (int i=0;i<size2.height;i++) {
   int c1=j+(i*size.width),c2=j+(i*size2.width);
   if ((pix[c1]==ibg)!=(pix[c1+size.width]==ibg)) pix2[c2]=true;
  }
  Vector ret=new Vector();
  boolean[] pix3=new boolean[pix2.length];
  System.arraycopy(pix2,0,pix3,0,pix2.length);
  ret.addElement(pix3);
  int w2=size.width>>1;
  int h2=size.height>>1;
  for (int i=0;i<pix2.length;i++) if (pix2[i]) {
   int y=i/size2.width;
   int x=i-(y*size2.width);
   poly3d poly=new poly3d(DISTANCE,w2,h2);
   boolean cont=true;
   while (cont) {
    poly.x.addElement(new Double((double)(x-w2)));
    poly.y.addElement(new Double((double)(h2-y)));
    poly.z.addElement(new Double((double)0));
    int j=0;
    boolean t=false;
    int lt=-1;
    while (cont) {
     pix2[x+y*size2.width]=false;
     int ct;
     if (y>0&&p(pix2,x,y-1,size2.width)) {
      y--;
      ct=0;
     } else if (x<size2.width-1&&p(pix2,x+1,y,size2.width)) {
      x++;
      ct=1;
     } else if (x>0&&p(pix2,x-1,y,size2.width)) {
      x--;
      ct=2;
     } else if (y<size2.height-1&&p(pix2,x,y+1,size2.width)) {
      y++;
      ct=3;
     } else if (x<size2.width-1&&y>0&&p(pix2,x+1,y-1,size2.width)) {
      y--;
      x++;
      ct=4;
     } else if (y<size2.height-1&&x<size2.width-1&&p(pix2,x+1,y+1,size2.width)) {
      x++;
      y++;
      ct=5;
     } else if (y>0&&x>0&&p(pix2,x-1,y-1,size2.width)) {
      x--;
      y--;
      ct=6;
     } else if (x>0&&y<size2.height-1&&p(pix2,x-1,y+1,size2.width)) {
      y++;
      x--;
      ct=7;
     } else {
      cont=false;
      break;
     }
     if (!(lt<0||lt==ct)) t=true;
     lt=ct;
     j++;
     if (j>crappyness&&t) break;
    }
   }
   poly.refresh();
   ret.addElement(poly);
  }
  return ret;
 }
 public static final boolean p(boolean[] pix,int x,int y,int w) {
  return pix[y*w+x];
 }
}

